> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mobilerun.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List devices

> Returns a paginated list of the user's devices along with pagination metadata.



## OpenAPI

````yaml /api-reference/phones.yaml get /devices
openapi: 3.1.0
info:
  title: Phones
  version: v1
servers:
  - url: https://api.mobilerun.ai
    description: Droidrun Cloud API
security:
  - bearerAuth: []
paths:
  /devices:
    get:
      tags:
        - Devices
      summary: List devices
      description: >-
        Returns a paginated list of the user's devices along with pagination
        metadata.
      operationId: list-devices
      parameters:
        - explode: false
          in: query
          name: state
          schema:
            default:
              - ready
            items:
              enum:
                - creating
                - assigned
                - ready
                - rebooting
                - migrating
                - resetting
                - terminated
                - maintenance
                - unknown
              type: string
            type:
              - array
              - 'null'
        - explode: false
          in: query
          name: type
          schema:
            enum:
              - dedicated_physical_device
              - dedicated_premium_device
              - dedicated_ios_device
              - dedicated_emulated_device
              - ios_simulator
            type: string
        - explode: false
          in: query
          name: country
          schema:
            type: string
        - explode: false
          in: query
          name: name
          schema:
            type: string
        - explode: false
          in: query
          name: providerId
          schema:
            type: string
        - explode: false
          in: query
          name: page
          schema:
            default: 1
            format: int64
            type: integer
        - explode: false
          in: query
          name: pageSize
          schema:
            default: 20
            format: int64
            type: integer
        - explode: false
          in: query
          name: orderBy
          schema:
            default: createdAt
            enum:
              - id
              - createdAt
              - updatedAt
              - assignedAt
            type: string
        - explode: false
          in: query
          name: orderByDirection
          schema:
            default: desc
            enum:
              - asc
              - desc
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseDeviceInfo'
          description: OK
        default:
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ErrorModel'
          description: Error
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Mobilerun from '@mobilerun/sdk';

            const client = new Mobilerun({
              apiKey: process.env['MOBILERUN_CLOUD_API_KEY'], // This is the default and can be omitted
            });

            const devices = await client.devices.list();

            console.log(devices.items);
        - lang: Python
          source: |-
            import os
            from mobilerun_sdk import Mobilerun

            client = Mobilerun(
                api_key=os.environ.get("MOBILERUN_CLOUD_API_KEY"),  # This is the default and can be omitted
            )
            devices = client.devices.list()
            print(devices.items)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stainless-sdks/droidrun-cloud-go\"\n\t\"github.com/stainless-sdks/droidrun-cloud-go/option\"\n)\n\nfunc main() {\n\tclient := mobileruncloud.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tdevices, err := client.Devices.List(context.TODO(), mobileruncloud.DeviceListParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", devices.Items)\n}\n"
        - lang: CLI
          source: |-
            mobilerun-cloud devices list \
              --api-key 'My API Key'
components:
  schemas:
    ResponseDeviceInfo:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/ResponseDeviceInfo.json
          format: uri
          readOnly: true
          type: string
        items:
          items:
            $ref: '#/components/schemas/DeviceInfo'
          type:
            - array
            - 'null'
        pagination:
          $ref: '#/components/schemas/Meta'
      required:
        - items
        - pagination
      type: object
    ErrorModel:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/ErrorModel.json
          format: uri
          readOnly: true
          type: string
        detail:
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
          examples:
            - Property foo is required but is missing.
          type: string
        errors:
          description: Optional list of individual error details
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type:
            - array
            - 'null'
        instance:
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem.
          examples:
            - https://example.com/error-log/abc123
          format: uri
          type: string
        status:
          description: HTTP status code
          examples:
            - 400
          format: int64
          type: integer
        title:
          description: >-
            A short, human-readable summary of the problem type. This value
            should not change between occurrences of the error.
          examples:
            - Bad Request
          type: string
        type:
          default: about:blank
          description: A URI reference to human-readable documentation for the error.
          examples:
            - https://example.com/errors/example
          format: uri
          type: string
      type: object
    DeviceInfo:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/DeviceInfo.json
          format: uri
          readOnly: true
          type: string
        activeTaskId:
          type: string
        assignedAt:
          format: date-time
          type:
            - string
            - 'null'
        billingStrategy:
          type: string
        createdAt:
          format: date-time
          type: string
        createdBy:
          type: string
        id:
          type: string
        name:
          type: string
        ownerId:
          type: string
        providerId:
          type: string
        state:
          type: string
        stateMessage:
          type: string
        streamToken:
          type: string
        streamUrl:
          type: string
        taskCount:
          format: int64
          type: integer
        terminatesAt:
          format: date-time
          type:
            - string
            - 'null'
        type:
          type: string
        updatedAt:
          format: date-time
          type: string
        userId:
          deprecated: true
          description: 'Deprecated: use ownerId/createdBy.'
          type: string
      required:
        - id
        - name
        - state
        - stateMessage
        - streamUrl
        - type
        - createdAt
        - updatedAt
        - assignedAt
        - terminatesAt
        - taskCount
        - activeTaskId
      type: object
    Meta:
      additionalProperties: false
      properties:
        hasNext:
          type: boolean
        hasPrev:
          type: boolean
        page:
          format: int64
          type: integer
        pageSize:
          format: int64
          type: integer
        pages:
          format: int64
          type: integer
        total:
          format: int64
          type: integer
      required:
        - hasNext
        - hasPrev
        - page
        - pageSize
        - total
        - pages
      type: object
    ErrorDetail:
      additionalProperties: false
      properties:
        location:
          description: >-
            Where the error occurred, e.g. 'body.items[3].tags' or
            'path.thing-id'
          type: string
        message:
          description: Error message text
          type: string
        value:
          description: The value at the given location
      type: object
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: Opaque
      description: Bearer token via Authorization header

````